from PIL import Image
import sys

replacer = {
    (0, 0, 0):"npc",
    (2, 2, 2):"npc",
    (5, 5, 5):"npc",

    (255, 0, 0):"next_level",
    (0, 255, 0):"prev_level",

    (209, 209, 209):"wall",
    (211, 211, 211):"wall",
    (214, 214, 214):"wall",
    (216, 216, 216):"wall",
    (219, 219, 219):"wall",
    (221, 221, 221):"wall",
    (224, 224, 224):"wall",
    (226, 226, 226):"wall",
    (229, 229, 229):"wall",
    (232, 232, 232):"wall",
    (234, 234, 234):"wall",
    (237, 237, 237):"wall",
    (239, 239, 239):"wall",
    (242, 242, 242):"wall",
    (244, 244, 244):"wall",
    (247, 247, 247):"wall",
    (249, 249, 249):"wall",
    (252, 252, 252):"wall",
    (255, 255, 255):"wall",

    (150, 0, 0):"gun",
    (151, 0, 0):"gun",

    (100, 140, 255):"sky",
}

unique = set()

im = Image.open(sys.argv[1])

width, height = im.size
for x in range(width):
    for y in range(height):
        unique.add(im.getpixel((x,y)))


pixels = dict((color, []) for color in unique)
for x in range(width):
    for y in range(height):
        pixels[im.getpixel((x,y))].append((x, y))

squares = {}
for key in pixels:
    topleft = None
    bottomright = None
    for pix in pixels[key]:
        if topleft is None:
            topleft = list(pix)
        if bottomright is None:
            bottomright = list(pix)

        topleft[0] = min(pix[0], topleft[0])
        topleft[1] = min(pix[1], topleft[1])
        bottomright[0] = max(pix[0], bottomright[0])
        bottomright[1] = max(pix[1], bottomright[1])

    topleft = topleft[0] * 30, topleft[1] * 30
    bottomright = (bottomright[0] + 1) * 30, (bottomright[1] + 1) * 30
    widthheight = bottomright[0] - topleft[0], bottomright[1] - topleft[1]

    squares[key] = (tuple(topleft), widthheight)

for square in squares:
    if square in replacer:
        word = replacer[square]
    else:
        word = square
    print(word, squares[square][0], squares[square][1], sep=',')
