from PIL import Image
import sys

replacer = {
    (0, 0, 0):"npc",

    (255, 0, 0):"next_level",
    (0, 255, 0):"prev_level",
    (255, 255, 255):"wall",

    (150, 0, 0):"gun",
    (151, 0, 0):"gun",

    (100, 140, 255):"sky",
}

unique = set()

im = Image.open(sys.argv[1])

width, height = im.size
pix = [(x, y) for x in range(width) for y in range(height)]

squares = []
while pix:
    p = pix[0]
    topleft = list(p)
    bottomright = list(p)
    stop = False
    while not stop:
        stop = True
        for direction in 'lurd':
            if direction == 'l':
                new_topleft = topleft[0] - 1, topleft[1]
                new_bottomright = tuple(bottomright)
                if new_topleft[0] < 0:
                    continue
            elif direction == 'u':
                new_topleft = topleft[0], topleft[1] - 1
                new_bottomright = tuple(bottomright)
                if new_topleft[1] < 0:
                    continue
            elif direction == 'r':
                new_topleft = tuple(topleft)
                new_bottomright = bottomright[0] + 1, bottomright[1]
                if new_bottomright[0] >= width:
                    continue
            elif direction == 'd':
                new_topleft = tuple(topleft)
                new_bottomright = bottomright[0], bottomright[1] + 1
                if new_bottomright[1] >= height:
                    continue
            success = True
            # print(new_topleft, new_bottomright, (width, height), topleft, bottomright, direction)
            for x in range(new_topleft[0], new_bottomright[0] + 1):
                for y in range(new_topleft[1], new_bottomright[1] + 1):
                    if im.getpixel((x, y)) != im.getpixel(new_topleft) or (x, y) not in pix:
                        success = False
            if success:
                stop = False
                topleft = new_topleft
                bottomright = new_bottomright

    for x in range(topleft[0], bottomright[0] + 1):
        for y in range(topleft[1], bottomright[1] + 1):
            pix.remove((x, y))

    squares.append((tuple(topleft), tuple(bottomright)))

for square in squares:
    # print(square)
    color = im.getpixel(square[0])
    if color in replacer:
        color = replacer[color]
    if color == 'sky':
        continue

    topleft = square[0][0] * 30, square[0][1] * 30
    bottomright = (square[1][0] + 1) * 30, (square[1][1] + 1) * 30
    widthheight = bottomright[0] - topleft[0], bottomright[1] - topleft[1]

    print(color, topleft, widthheight, sep=',')
